unit hiMTStrTbl; { MT-   }

interface

uses Windows, Messages, Share, Win, Debug, ListEdit, Kol,{ ShellAPI,}
     hiIconsManager, hiMST_DrawManager;

const

   ITM_ADD            =  -3;
   ITM_INSERT         =  -4;
   ITM_REPLACE        =  -5;

   COL_NAME           =  -9;
   COL_WIDTH          = -10;
   COL_IMAGE          = -11;
   COL_ALIGN          = -12;

   AColor: array [0..15] of TColor =
		   (clBlack, clMaroon, clGreen, clOlive, clNavy, clPurple, clTeal, clGray,
		   clSilver, clRed, clLime, clYellow, clBlue, clFuchsia, clAqua, clWhite);

type
  TIMSTControl = record
    ctrlpoint:function:pointer of object;
    actionitm:procedure(var Data:TData; Mode:integer) of object;
    actioncol:procedure(var Data:TData; Mode:integer) of object;    
    propercol:procedure(var Data:TData; Mode:integer) of object;
    textalign:function(idx:integer):TTextAlign of object;    
    imgcolumn:function:boolean of object;
    smiconlist:function:PImageList of object;
    colcount:function:integer of object;
    checkboxes:function:boolean of object;
    imgsize:function:byte of object;
    coloritems:function:boolean of object;
    scoloritems:procedure(val:boolean) of object;
    textbkcolor:function: TColor of object;
    textcolor:function: TColor of object;
    bkcolor:function: TColor of object;
    gradientcolor:function: TColor of object;
    shadowcolor:function: TColor of object;
    iconcolcolor:function: TColor of object;
    addcols:procedure(var _Data:TData; FAllMT_AddCol:boolean) of object;
    stextbkcolor:procedure(Value: TColor) of object;
    stextcolor:procedure(Value: TColor) of object;
    sbkcolor:procedure(Value: TColor) of object;
    sgradientcolor:procedure(Value: TColor) of object;
    sshadowcolor:procedure(Value: TColor) of object;
    siconcolcolor:procedure(Value: TColor) of object;
    deletecol:procedure(var _Data:TData) of object;
    clearcol:procedure(var _Data:TData) of object;
    clistclear:procedure of object;
    clistcount:function:integer of object;    
    style:function:TListViewStyle of object;
    select:procedure(var _Data:TData; Index:word) of object;
    index:procedure(var _Data:TData; Index:word) of object;
    setfocus:procedure(var _Data:TData; Index:word) of object;
    add:procedure(const Data:string; Index:integer = -1; _Replace:boolean = false) of object;
    getnewcuridx:function:integer of object;
    setnewcuridx:procedure(value:integer) of object;
    getfredaction:function:boolean of object;
    getfctl3d:function:boolean of object;
    matrix:procedure(var _Data:TData; Index:word) of object;
    mxget:function(x,y:integer):TData of object;
  end;
  IMSTControl = ^TIMSTControl;

type
  ThiMTStrTbl = class(THIWin)
   private
    mtstc: TIMSTControl; 
   
    FLargIconsManager:IIconsManager;
    FSmallIconsManager:IIconsManager;
    FStateIconsManager:IIconsManager;

    NewCurIdx: integer;
    FData,FData_2: TData;
    Obj:PMatrix;
    Arr,CBArray,SAArray,CLArray:PArray;
    LgIList,SmIList,StIList:PImageList;
    CList:PStrList;
    _StrDlm:char;
    _ColorDlm:char;
    _ColDlm:char;
    
    FStyle: TListViewStyle;
    FTextAlign: TTextAlign;

    FCTL3D,
    FStaticColumn,
    FColorItems,
    FGrid,
    FHeaderDragDrop,
    FTrackSelect,
    FRowSelect,
    FCheckBoxes,
    FMultiSelect,
    FFlat,
    FImgColumn,
    FFullSelect,
    FRedaction,
    FEnableOnClick,
    FInfoTip: boolean;    

    FColumnClick,
    FImgSize: byte;

    FColumnWidth:integer;

    FIconColColor,
    FGradientColor,
    FShadowColor: TColor;

    function ctrlpoint: pointer;
    function smiconlist: PImageList;
    function textalign(idx:integer): TTextAlign;
    function imgcolumn: boolean;
    function colcount: integer;
    function checkboxes: boolean;
    function imgsize: byte;    
    function coloritems: boolean;
    procedure scoloritems(val:boolean);    
    function textbkcolor: TColor;
    function textcolor: TColor;
    function bkcolor: TColor;
    function gradientcolor: TColor;
    function shadowcolor: TColor;
    function iconcolcolor: TColor;
    procedure addcols(var _Data:TData; FAllMT_AddCol:boolean);
    procedure stextcolor(Value: TColor);
    procedure stextbkcolor(Value: TColor);
    procedure sbkcolor(Value: TColor);
    procedure sgradientcolor(Value: TColor);
    procedure sshadowcolor(Value: TColor);
    procedure siconcolcolor(Value: TColor);
    procedure clearcol(var _Data:TData);
    procedure deletecol(var _Data:TData);
    procedure clistclear;
    function clistcount:integer;
    function style:TListViewStyle;
    function getnewcuridx:integer;
    procedure setnewcuridx(value:integer);
    function getfredaction:boolean;
    function getfctl3d:boolean;

    procedure StrDlm(Val:string);
    procedure ColorDlm(Val:string);    
    procedure ColDlm(Val:string);    
     
    procedure SetColumns(const ListCol:PStrList; Mode:integer);
    procedure _OnColumnClick(Sender: PControl; Idx: Integer);
    procedure _OnBeforeLineChange(Sender: PControl; Idx: Integer);
    procedure _OnLineChange(Sender: PControl; Idx: Integer);
    function  _OnLVCustomDraw(Sender: PControl; DC: HDC; Stage: DWORD;
                  ItemIdx, SubItemIdx: Integer; const Rect: TRect;
                  ItemState: TDrawState; var TextColor, BackColor: TColor): DWORD;
    procedure Add(const Data:string; Index:integer = -1; _Replace:boolean = false);
    function _Count:integer;
    procedure MX_Set(x,y:integer; var Val:TData);
    function MX_Get(x,y:integer):TData;
    function _mRows:integer;
    function _mCols:integer;
    procedure CB_Set(var Item:TData; var Val:TData);
    function CB_Get(Var Item:TData; var Val:TData):boolean;
    procedure SA_Set(var Item:TData; var Val:TData);
    function SA_Get(Var Item:TData; var Val:TData):boolean;
    function InitColStr(var Val:string):string;
    procedure _SetCol(var Item:TData; var Val:TData);
    function _GetCol(Var Item:TData; var Val:TData):boolean;
    procedure _AddCol(var Val:TData);
    function _CountCol:integer;
    procedure SetTextColLst(const Value:string);
    function Get(index:integer):string;
    procedure _aSet(var Item:TData; var Val:TData);
    function _aGet(Var Item:TData; var Val:TData):boolean;
    procedure _aAdd(var Val:TData);
    function PakColor2Str(data:dword):string;
    procedure SetOption(OSet:boolean; Option:TListViewOption); 

    procedure _OnSelState( Sender: PControl; IdxFrom, IdxTo: Integer; OldState, NewState: cardinal );

    procedure MT_ActionItm(var Data:TData; Mode:integer);
    procedure MT_ActionCol(var Data:TData; Mode:integer);
    procedure MT_ProperCol(var Data:TData; Mode:integer);

    procedure SetLargIconsManager(value:IIconsManager);
    procedure SetSmallIconsManager(value:IIconsManager);
    procedure SetStateIconsManager(value:IIconsManager);

   public

    _data_EndEdit:THI_Event;
    _event_onClick:THI_Event;
    _event_onColumnClick:THI_Event;
    _event_onMT_Check:THI_Event;
    _event_onBeforeLineChange:THI_Event;
    _event_onLineChange:THI_Event;
    _prop_DrawManager:IDrawManager;
    
    property _prop_LargIconsManager:IIconsManager   read FLargIconsManager  write SetLargIconsManager;
    property _prop_SmallIconsManager:IIconsManager  read FSmallIconsManager write SetSmallIconsManager;
    property _prop_StateIconsManager:IIconsManager  read FStateIconsManager write SetStateIconsManager;

    property _prop_ColorItems:boolean      write FColorItems;
    property _prop_InfoTip:boolean         write FInfoTip;
    property _prop_EnableOnClick:boolean   write FEnableOnClick;
    property _prop_ColumnWidth:integer     write FColumnWidth;
    property _prop_Redaction:boolean       write FRedaction;
    property _prop_ImgColumn:boolean       write FImgColumn;
    property _prop_FullSelect:boolean      write FFullSelect;
    property _prop_ColumnClick:byte        write FColumnClick;
    property _prop_StaticColumn:boolean    write FStaticColumn;
    property _prop_TextAlign:TTextAlign    write FTextAlign;
    property _prop_Style:TListViewStyle    write FStyle;
    property _prop_Grid:boolean            write FGrid;
    property _prop_HeaderDragDrop:boolean  write FHeaderDragDrop;
    property _prop_TrackSelect:boolean     write FTrackSelect;
    property _prop_RowSelect:boolean       write FRowSelect;
    property _prop_CheckBoxes:boolean      write FCheckBoxes;
    property _prop_MultiSelect:boolean     write FMultiSelect;
    property _prop_StrDelimiter:string     write StrDlm;
    property _prop_ColorDelimiter:string   write ColorDlm;
    property _prop_ColDelimiter:string     write ColDlm;
    
    property _prop_Columns:string          write SetTextColLst;

    procedure Init; override;
    destructor Destroy; override;

    function getInterfaceMSTControl: IMSTControl;

    procedure _work_doMT_CheckBox(var _Data:TData; Index:word);
    procedure _work_doCheckBoxes(var _Data:TData; Index:word);

    procedure _work_doStyle(var _Data:TData; Index:word);
    procedure _work_doTextAlign(var _Data:TData; Index:word);
    procedure _work_doFlat(var _Data:TData; Index:word);
    procedure _work_doGrid(var _Data:TData; Index:word);
    procedure _work_doStaticColumn(var _Data:TData; Index:word);
    procedure _work_doHeaderDragDrop(var _Data:TData; Index:word);
    procedure _work_doInfoTip(var _Data:TData; Index:word);
    procedure _work_doTrackSelect(var _Data:TData; Index:word);
    procedure _work_doRowSelect(var _Data:TData; Index:word);
    procedure _work_doMultiSelect(var _Data:TData; Index:word);

    procedure _work_doEndEdit(var _Data:TData; Index:word);
    procedure _work_doEnableOnClick(var _Data:TData; Index:word);
    procedure _var_AllSelect_MT(var _Data:TData; Index:word);
    procedure _var_AllCheck_MT(var _Data:TData; Index:word);
    procedure _var_Count(var _Data:TData; Index:word);
    procedure _var_EndIdx(var _Data:TData; Index:word);    
    procedure _var_Select(var _Data:TData; Index:word);
    procedure _var_Matrix(var _Data:TData; Index:word);
    procedure _var_Strings(var _Data:TData; Index:word);
    procedure _var_TopItem(var _Data:TData; Index:word);
    procedure _var_PerPage(var _Data:TData; Index:word);
    procedure _var_ItemAtPos(var _Data:TData; Index:word);    
    procedure _var_Index(var _Data:TData; Index:word);
    procedure _var_MTStrTbl(var _Data:TData; Index:word);
    procedure _var_SelectArray(var _Data:TData; Index:word);
    procedure _var_ColumnArray(var _Data:TData; Index:word);
    procedure _var_CheckBoxes(var _Data:TData; Index:word);
    procedure _var_CountCol(var _Data:TData; Index:word);
    procedure _var_EndIdxCol(var _Data:TData; Index:word);    
    procedure _var_FullTextTab(var _Data:TData; Index:word);    
  end;

implementation

function ThiMTStrTbl.getInterfaceMSTControl;
begin
  Result := @mtstc;
end;

function ThiMTStrTbl.ctrlpoint;
begin
  Result := Control;
end;

function ThiMTStrTbl.textalign;
begin
  Result := Control.LVColAlign[idx];
end;

function ThiMTStrTbl.smiconlist;
begin
   if Assigned(SmIList) then
     Result:= SmIList
   else
     Result:= nil;
end;

function ThiMTStrTbl.imgcolumn;
begin
  Result := FImgColumn;
end;

function ThiMTStrTbl.colcount;
begin
  Result := CList.Count;
end;

function ThiMTStrTbl.checkboxes;
begin
  Result := FCheckBoxes;
end;

function ThiMTStrTbl.imgsize;
begin
  Result := FImgSize;
end;

function ThiMTStrTbl.coloritems;
begin
  Result := FColorItems;
end;

procedure ThiMTStrTbl.scoloritems;
begin
  FColorItems := val;
end;

function ThiMTStrTbl.textcolor;
begin
  Result := Control.LVTextColor;
end;

function ThiMTStrTbl.textbkcolor;
begin
  Result:= Control.LVTextBkColor;
end;

procedure ThiMTStrTbl.bkcolor;
begin
  Result:= Control.LVBkColor;
end;

function ThiMTStrTbl.gradientcolor;
begin
  Result:= FGradientColor;
end;

procedure ThiMTStrTbl.shadowcolor;
begin
  Result:= FShadowColor;
end;

function ThiMTStrTbl.iconcolcolor;
begin
  Result := FIconColColor;
end;

function ThiMTStrTbl.style;
begin
  Result := FStyle;
end;

function ThiMTStrTbl.getnewcuridx;
begin
  Result := NewCurIdx;
end;

procedure ThiMTStrTbl.setnewcuridx;
begin
   NewCurIdx := Value;
end;

function ThiMTStrTbl.getfredaction;
begin
  Result := FRedaction;
end;

procedure ThiMTStrTbl.siconcolcolor;
begin
  FIconColColor:= Value;
  if Assigned(SmIList) then
    SmIList.BkColor:= FIconColColor;
  SetColumns(CList,1);      
end;

function ThiMTStrTbl.clistcount;
begin
  Result := CList.Count;
end;

function ThiMTStrTbl.getfctl3d;
begin
  Result := FCtl3D;
end;

procedure ThiMTStrTbl.addcols; // 
var
  s:string;
begin
  if _IsNULL(_Data) then exit;

  if not FAllMT_AddCol then
  begin
    ReadString(_Data,Null);
    ReadString(_Data,Null);
  end;      
  while not _IsNULL(_Data) do
  begin
      s := ReadString(_Data,Null);
      Replace(s, _ColDlm, '=');
      Control.LVColAdd('',FTextAlign,FColumnWidth);
      CList.Add(InitColStr(s));
  end; 
  SetColumns(CList,1);
end;

procedure ThiMTStrTbl.clistclear;
begin
  Clist.Clear;
end;

destructor ThiMTStrTbl.Destroy;
begin
   CList.free;
   if Obj <> nil           then Dispose(Obj);
   if CBArray <> nil       then Dispose(CBArray);
   if SAArray <> nil       then Dispose(SAArray);
   if CLArray <> nil       then Dispose(CLArray);
   FreeData(@FData);      
   FreeData(@FData_2);
   inherited Destroy;
end;

procedure ThiMTStrTbl._OnColumnClick;
begin
   case FColumnClick of
     0: _hi_OnEvent(_event_onColumnClick,Control.LVColText[Idx]);
     1: _hi_OnEvent(_event_onColumnClick,Idx);
   end;
end;

procedure ThiMTStrTbl._OnBeforeLineChange;begin _hi_OnEvent(_event_onBeforeLineChange,Idx);end;
procedure ThiMTStrTbl._OnLineChange;begin _hi_OnEvent(_event_onLineChange,Idx);end;

//---------------------       -----------------------

procedure ThiMTStrTbl._OnSelState;
var   dt,Data:TData;
begin
   dtNull(Data);
   if (Newstate = 3) or (Newstate = 1) then begin
      if  FEnableOnClick then _hi_OnEvent(_event_onClick, IdxFrom);
      exit;
   end;
   if (Newstate = $2000) and (OldState =  $1000) then
      dtInteger(dt,1)
   else if (Newstate = $1000) and (OldState =  $2000) then
      dtInteger(dt,0)
   else exit;         
   dtInteger(Data,IdxFrom);
   Data.ldata:= @dt;
   _hi_onEvent_(_event_onMT_Check,Data);
end;

//---------------------       -----------------------

function ThiMTStrTbl._OnLVCustomDraw;
var
  Color,bkColor: TColor;
  idxColor: dword;
begin
  Result:= CDRF_DODEFAULT;
  if (Stage = CDDS_PREPAINT) then
    Result:= CDRF_NOTIFYITEMDRAW

  else if (Stage = CDDS_ITEMPREPAINT) then
  begin 
    if (Sender.LVItemData[ItemIdx] <> 0) and FColorItems then
    begin
      Color:= Sender.LVItemData[ItemIdx];
      bkColor:= $00FFFFFF and Color;
      if bkColor <> 0 then
        BackColor:= bkColor
      else
        BackColor:= Color2RGB(Sender.LVBkColor);
      idxColor:= ($0F000000 and Color) shr 24;
      if idxColor <> 0 then
        TextColor:= AColor[idxColor]
      else
        TextColor:= Color2RGB(Sender.LVTextColor);
    end
    else
    begin 
      BackColor:= Color2RGB(Sender.LVTextBkColor);
      TextColor:= Color2RGB(Sender.LVTextColor);
    end;
    Result:=CDRF_NOTIFYSUBITEMDRAW OR CDRF_NOTIFYPOSTPAINT;
  end
  else if ((Stage = CDDS_SUBITEM + CDDS_ITEMPREPAINT) or (Stage = CDDS_ITEMPOSTPAINT))
          and ((Sender.LVStyle = lvsDetail) or (Sender.LVStyle = lvsDetailNoHeader))
          and Assigned(_prop_DrawManager) then
    Result := _prop_DrawManager.customdraw(Sender, DC, Stage, ItemIdx, SubItemIdx, Rect,
                                          ItemState, TextColor, BackColor, FGradientColor,
                                          FShadowColor, NewCurIdx, SmIList, StIList);
end;
//-------------------    ---------------------


//------------------------------------------------------------------------

function ThiMTStrTbl.PakColor2Str;
var
  hcl,lcl:string;
  idxcl:dword;
begin
  lcl:= int2str($FFFFFF and data);
  idxcl:= $0F000000 and data;
  hcl:= int2str(idxcl shr 24);
  Result:= hcl + _ColorDlm + lcl;
end;

procedure ThiMTStrTbl.StrDlm;
begin
  if Val = '' then
    _StrDlm:= ' '
  else
    _StrDlm:= Val[1];
end;

procedure ThiMTStrTbl.ColorDlm;
begin
  if Val = '' then
    _ColorDlm:= '#'
  else
    _ColorDlm:= Val[1];
end;

procedure ThiMTStrTbl.ColDlm;
begin
  if Val = '' then
    _ColDlm:= '_'
  else
    _ColDlm:= Val[1];
end;

//==============================================================================

procedure ThiMTStrTbl.Init;
var
  l: TListViewOptions;
begin
  FFlat := _prop_Flat;
  l:= [lvoUnderlineHot];

  if FInfoTip then include(l,lvoInfoTip);
  if FTrackSelect then include(l,lvoTrackSelect);
  if FHeaderDragDrop then include(l,lvoHeaderDragDrop);
  if FCheckBoxes then include(l,lvoCheckBoxes);
  if FMultiSelect then include(l,lvoMultiSelect);
  if FGrid then include(l,lvoGridLines);
  if FRowSelect then include(l,lvoRowSelect);
  if FFlat then include(l,lvoFlatsb);
   
  FGradientColor := clHighlight;
  FShadowColor := clHighlightText;
  FIconColColor := clBtnFace;

  if _prop_StateIconsManager = nil then
    StIList := nil
  else 
    StIList := _prop_StateIconsManager.iconlist;

  if _prop_SmallIconsManager = nil then
    SmIList := nil
  else
  begin 
    SmIList := _prop_SmallIconsManager.iconlist;
    FImgSize := _prop_SmallIconsManager.imgsz;
    SmIList.BkColor:= FIconColColor;
  end;


  if _prop_LargIconsManager = nil then
    LgIList := nil
  else 
    LgIList := _prop_LargIconsManager.iconlist;

  if FRedaction then
    Control := NewListEdit(FParent,FStyle,l,LgIList,SmIList,StIList,
                           _OnLineChange,_OnBeforeLineChange)
  else
    Control := NewListView(FParent,FStyle,l,LgIList,SmIList,StIList);

  mtstc.ctrlpoint      := ctrlpoint;
  mtstc.actionitm      := MT_ActionItm;
  mtstc.actioncol      := MT_ActionCol;
  mtstc.propercol      := MT_ProperCol;
  mtstc.textalign      := textalign;
  mtstc.smiconlist     := smiconlist;
  mtstc.imgcolumn      := imgcolumn;
  mtstc.colcount       := colcount;
  mtstc.checkboxes     := checkboxes;
  mtstc.imgsize        := imgsize;     
  mtstc.coloritems     := coloritems;
  mtstc.scoloritems    := scoloritems;
  mtstc.textbkcolor    := textbkcolor;
  mtstc.textcolor      := textcolor;
  mtstc.bkcolor        := bkcolor;
  mtstc.gradientcolor  := gradientcolor;
  mtstc.shadowcolor    := shadowcolor;  
  mtstc.addcols        := addcols;
  mtstc.stextbkcolor   := stextbkcolor;
  mtstc.stextcolor     := stextcolor;
  mtstc.sbkcolor       := sbkcolor;
  mtstc.sgradientcolor := sgradientcolor;
  mtstc.sshadowcolor   := sshadowcolor;
  mtstc.siconcolcolor  := siconcolcolor;
  mtstc.iconcolcolor   := iconcolcolor;  
  mtstc.deletecol      := deletecol;
  mtstc.clearcol       := clearcol;
  mtstc.clistclear     := clistclear;
  mtstc.clistcount     := clistcount;
  mtstc.style          := style;
  mtstc.select         := _var_Select;
  mtstc.index          := _var_Index;
  mtstc.setfocus       := _work_doSetFocus;
  mtstc.add            := Add;
  mtstc.matrix         := _var_Matrix;
  mtstc.mxget          := MX_Get;
  mtstc.getnewcuridx   := getnewcuridx;
  mtstc.setnewcuridx   := setnewcuridx;
  mtstc.getfredaction  := getfredaction;
  mtstc.getfctl3d      := getfctl3d;

  Control.OnColumnClick  :=  _OnColumnClick;
  Control.OnLVCustomDraw :=  _OnLVCustomDraw;
  SetColumns(CList,0);

  inherited;

  FCTL3D := not boolean(_prop_CTL3D);

  Control.LVTextColor   := Control.Font.Color;
  Control.LVTextBkColor := Control.Color;
  Control.LVBkColor     := Control.Color;
  Control.OnLVStateChange:= _OnSelState;

  Control.InvaliDate;
end;

procedure ThiMTStrTbl.SetTextColLst;
begin
   CList:= NewStrList;
   Clist.Text:= Value;
end;

procedure ThiMTStrTbl.SetColumns;
var   i:integer;
      s,str,sd:string;
begin
   if ListCol.Count = 0 then exit;
   i:= 0;
//   Control.BeginUpdate;
   repeat
      s:= ListCol.Items[i] + '=';
      sd:= GetTok(s,'=');
      if sd <> '' then begin
         str:= sd;
         case Mode of
            0:  Control.LVColAdd(sd,FTextAlign,FColumnWidth);
            1:  Control.LVColText[i]:= sd;
         end;
         sd:= GetTok(s,'=');
         if sd = '' then
            sd:= int2str(FColumnWidth)
         else
            Control.LVColWidth[i]:= max(LVSCW_AUTOSIZE_USEHEADER,str2int(sd));
         str:= str + '=' + sd;
         sd:= GetTok(s,'=');
         if FImgColumn and Assigned(SmIlist) and (SmIList.Count <> 0) then
           if sd = '' then
             Control.LVColImage[i]:= I_SKIP
           else  
             Control.LVColImage[i]:= str2int(sd);
         str:= str + '=' + sd;
         sd:= GetTok(s,'=');
         if sd <> '' then
            Control.LVColAlign[i]:= TTextAlign(str2int(sd))
         else begin
            Control.LVColAlign[i]:= FTextAlign;
            sd:= int2str(integer(Control.LVColAlign[i]));
         end;
         str:= str + '=' + sd;
         ListCol.Items[i]:= str;
      end;
      inc(i);
   until i = ListCol.Count; 
//   Control.EndUpDate;
end;

//     
//
procedure ThiMTStrTbl.Add;
var   s,ss:string;
      i,ico,ind:integer;
      DColor:dword;       
begin
   s:= Data + _StrDlm;
   i:= 0;
   ico:= I_SKIP;
   DColor:= 0;
   if Index = -1 then begin
      Control.LVItemAdd('');
      Index:= Control.Count-1;
   end else if not _replace then Control.LVItemInsert(Index,'');
   if Assigned(SmIlist) then ico:= Str2Int(gettok(s,_StrDlm));
   if FColorItems then begin
      ss:= gettok(s,_StrDlm) + _ColorDlm;
      DColor:= dword(Str2Int(GetTok(ss,_ColorDlm)) shl 24 + Str2int(ss));
   end;
   ind := Control.LVCurItem; //    
   repeat
      Control.LVSetItem(Index,i,gettok(s,_StrDlm),ico,[],I_SKIP,I_SKIP,DColor);
      inc(i);
   until s = '';
   Control.LVCurItem := ind; //   
end;

function ThiMTStrTbl.Get;
var   i:integer;
      s:string;
begin
   Result := '';
   if Control.LVColCount > 0 then
      begin
         s:= '';
         if Assigned(SmIlist) and FFullSelect then
            s:= int2str(Control.LVItemImageIndex[Index]) + _StrDlm;
         if FColorItems and FFullSelect  then
            s:= s + PakColor2Str(Control.LVItemData[Index]) + _StrDlm;;
         for i:= 0 to Control.LVColCount - 1 do
            begin
               s:= s + Control.LVItems[Index,i];
               if i < Control.LVColCount - 1 then
                  s:= s + _StrDlm;
            end;
         Result:= s;   
      end;
end;

procedure ThiMTStrTbl._aSet;
var ind:integer;
begin
   ind := ToIntIndex(Item);
   if(ind >= 0)and(ind < Control.Count)then
      Add(ToString(val),ind, true);
end;

procedure ThiMTStrTbl._aAdd;
begin
   Add(ToString(val), -1);
end;

function ThiMTStrTbl._aGet;
var ind:integer;
begin
   ind := ToIntIndex(Item);
   if(ind >= 0)and(ind < Control.Count)then
     begin
        Result := true;
        dtString(Val,Get(ind));
     end
   else Result := false;
end;

//_Count -  
//
function ThiMTStrTbl._Count;
begin
   Result := Control.Count;
end;

//Strings -   ,      ,  StrDelimiter'
//
procedure ThiMTStrTbl._var_Strings;
begin
  if arr = nil then
     arr := CreateArray(_aset,_aget,_Count,_aadd);
  dtArray(_Data,Arr);
end;

//Count -     
//
procedure ThiMTStrTbl._var_Count;
begin
   dtInteger(_Data,Control.Count);
end;

//EndIdx -      
//
procedure ThiMTStrTbl._var_EndIdx;
begin
   if Control.Count = 0 then dtNull(_Data)
   else dtInteger(_Data,Control.Count - 1);
end;

//Select -     ,   StrDelimiter

procedure ThiMTStrTbl._var_Select;
begin
   if Control.LVCurItem = -1 then
      dtString(_Data,'')
   else
      dtString(_Data, Get(Control.LVCurItem));
end;

//Index -    
//
procedure ThiMTStrTbl._var_Index;
begin
   dtInteger(_Data, Control.CurIndex);
end;

//FullTextTab -        
//                     10  13
//
procedure ThiMTStrTbl._var_FullTextTab;
var   i,j:integer;
      s:string;
begin
   if (Control.Count = 0) or (Control.LVColCount = 0) then Exit;
   s:= '';
   j:= 0;
   repeat
      if Assigned(SmIlist) then s:= s + int2str(Control.LVItemImageIndex[j]) + _StrDlm;
      if FColorItems then s:= s + PakColor2Str(Control.LVItemData[j]) + _StrDlm;
      i:= 0;
      repeat
         s:= s + Control.LVItems[j,i];
         if i < Control.LVColCount - 1 then s:= s + _StrDlm;
         inc(i);
      until i > Control.LVColCount - 1; 
      s:= s + #13#10;
      inc(j);
   until j > Control.Count - 1;
   dtString(_Data,s);
end;

//TopItem -   ,     
//
procedure ThiMTStrTbl._var_TopItem;
begin
   dtInteger(_Data,Control.LVTopItem);
end;

//PerPage -    ,    
//
procedure ThiMTStrTbl._var_PerPage;
begin
   dtInteger(_Data,Control.LVPerPage);
end;

//ItemAtPos -   ,    PosX, PosY  
//
procedure ThiMTStrTbl._var_ItemAtPos;
begin
   dtInteger(_Data, Control.LVItemAtPos(Ms.X, Ms.Y));
end;

//StringTable -    
//
procedure ThiMTStrTbl._var_MTStrTbl;
begin
   _Data.Data_type := data_int;
   _Data.sdata := 'StringTable';
   _Data.idata := integer(Control);
end;

//SelectArray -   
//
procedure ThiMTStrTbl._var_SelectArray;
begin
   if not Assigned(SAArray) then
      SAArray := CreateArray(SA_Set,SA_Get,_Count,nil);
   dtArray(_Data,SAArray);
end;

procedure ThiMTStrTbl.SA_Set(var Item:TData; var Val:TData);
var   ind:integer;
begin
   ind:= ToIntIndex(Item);
   if (ind >= 0)and(ind < Control.Count)and(ToInteger(Val) = 1) then
   Control.LVItemState[ind]:= [lvisSelect];
end;

function ThiMTStrTbl.SA_Get(Var Item:TData; var Val:TData):boolean;
var  ind:integer;
begin
   ind:= ToIntIndex(Item);
   Result:= True;
   if (ind >= 0)and(ind < Control.Count) then
      if lvisSelect in Control.LVItemState[ind] then dtInteger(Val,1) else dtInteger(Val,0)
   else Result:= False;
end;

//CheckBoxes -    (0 -  , 1 - )
//
procedure ThiMTStrTbl._var_CheckBoxes;
begin
   if not Assigned(CBArray) then
      CBArray := CreateArray(CB_Set,CB_Get,_Count,nil);
   dtArray(_Data,CBArray);
end;

procedure ThiMTStrTbl.CB_Set(var Item:TData; var Val:TData);
var   ind:integer;
begin
   ind:= ToIntIndex(Item);
   if (ind >= 0)and(ind < Control.Count) then
      Control.LVItemStateImgIdx[ind]:= toInteger(Val) + 1;
end;

function ThiMTStrTbl.CB_Get(Var Item:TData; var Val:TData):boolean;
var   ind:integer;
begin
   ind:= ToIntIndex(Item);
   if (ind >= 0)and(ind < Control.Count) then
      begin
         dtInteger(Val,Control.LVItemStateImgIdx[ind] - 1);
         Result:= True;
      end
   else Result:= False;
end;

//#####################################################################
//#                                                                   #
//#                                                   #
//#                                                                   #
//#####################################################################

procedure ThiMTStrTbl.stextcolor;begin Control.LVTextColor:= Value;end;
procedure ThiMTStrTbl.stextbkcolor;begin Control.LVTextBkColor:= Value;end;
procedure ThiMTStrTbl.sbkcolor;begin Control.LVBkColor:= Value;end;
procedure ThiMTStrTbl.sgradientcolor;begin FGradientColor:= Value;end;
procedure ThiMTStrTbl.sshadowcolor;begin FShadowColor:= Value;end;

procedure ThiMTStrTbl._work_doStyle;begin FStyle:= TListViewStyle(ToInteger(_Data));Control.LVStyle:= FStyle;SetColumns(Clist,1);end;
procedure ThiMTStrTbl._work_doTextAlign;begin FTextAlign:= TTextAlign(ToInteger(_Data));end;
procedure ThiMTStrTbl._work_doStaticColumn;begin FStaticColumn:= ReadBool(_Data);end;
procedure ThiMTStrTbl._work_doEnableOnClick;begin FEnableOnClick:= ReadBool(_Data);end;

procedure ThiMTStrTbl._work_doGrid;
begin
   FGrid:= ReadBool(_Data);
   SetOption(FGrid,lvoGridLines);
end;

procedure ThiMTStrTbl._work_doFlat;
begin
   FFlat:= ReadBool(_Data);
   SetOption(FFlat,lvoFlatsb);
end;

procedure ThiMTStrTbl._work_doHeaderDragDrop;
begin
   FHeaderDragDrop:= ReadBool(_Data);
   SetOption(FHeaderDragDrop,lvoHeaderDragDrop);
end;

procedure ThiMTStrTbl._work_doTrackSelect;
begin
   FTrackSelect:= ReadBool(_Data);
   SetOption(FTrackSelect,lvoTrackSelect);
end;

procedure ThiMTStrTbl._work_doRowSelect;
begin
   FRowSelect:= ReadBool(_Data);
   SetOption(FRowSelect,lvoRowSelect);
end;

procedure ThiMTStrTbl._work_doCheckBoxes;
begin
   If FStateIconsManager <> nil then exit;
   FCheckBoxes:= ReadBool(_Data);
   SetOption(FCheckBoxes,lvoCheckBoxes);
end;

procedure ThiMTStrTbl._work_doMultiSelect;
begin
   FMultiSelect:= ReadBool(_Data);
   SetOption(FMultiSelect,lvoMultiSelect);
end;

procedure ThiMTStrTbl._work_doInfoTip;
begin
   FInfoTip:= ReadBool(_Data);
   SetOption(FInfoTip,lvoInfoTip);
end;

procedure ThiMTStrTbl.SetOption;
var   l:TListViewOptions;
begin
   l:= Control.LVOptions;
   if OSet then include(l,Option)
   else exclude(l,Option);
   Control.LVOptions:= l;
end;

//#####################################################################
//#                                                                   #
//#                               #
//#                                                                   #
//#####################################################################

//------------------         --------------------

//ColumnArray -    
//
procedure ThiMTStrTbl._var_ColumnArray;
begin
  if not Assigned(CLArray) then
     CLArray := CreateArray(_SetCol,_GetCol,_CountCol,_AddCol);
  dtArray(_Data,CLArray);
end;

procedure ThiMTStrTbl._SetCol(var Item:TData; var Val:TData);
var   s:string;
      ind:integer;
begin
   ind:= ToIntIndex(Item);
   s:= ToString(Val);
   if(ind >= 0)and(ind < CList.Count) then CList.Items[ind]:=InitColStr(s);
   SetColumns(CList,1);
end;

function ThiMTStrTbl._GetCol(Var Item:TData; var Val:TData):boolean;
var   ind:integer;
begin
   ind:= ToIntIndex(Item);
   Result:= True;
   if(ind >= 0)and(ind < CList.Count) then
      dtString(Val,Clist.Items[ind])
   else Result:= False;
end;

function ThiMTStrTbl._CountCol:integer;
begin
   Result:= CList.Count;
end;

procedure ThiMTStrTbl._AddCol(var Val:TData);
var
  s:string;
begin
   s:= ToString(Val);
   Control.LVColAdd('',FTextAlign,FColumnWidth);
   CList.Add(InitColStr(s));
   SetColumns(CList,1);
end;

//--------------------       -----------------------

//doDeleteCol -    
//
procedure ThiMTStrTbl.deletecol;
var   ind:integer;
begin
   ind:= ToInteger(_Data);
   if (ind >= 0) and (ind < CList.Count) then
      begin
         Control.LVColDelete(ind);
         CList.Delete(ind);
      end;
   SetColumns(CList,1);
end;

//doClearCol -   
//
procedure ThiMTStrTbl.clearcol;
var   x,y:integer;
      dt:TData;
begin
    dtNull(dt);
    x:= ToInteger(_Data);
    if (x >= 0) and (x < CList.Count) then
       for y:= 0 to Control.Count - 1 do MX_Set(x,y,dt);
end;

function ThiMTStrTbl.InitColStr;
var   s,ss,sd,se,sf,sh:string;
begin
   s:= val;
   sf:= s + '=';
   ss:= GetTok(sf,'=');
   sd:= GetTok(sf,'=');
   sh:= GetTok(sf,'=');
   se:= GetTok(sf,'=');
   if s = '' then s:= '=' + int2str(FColumnWidth) + '=' + int2str(integer(FTextAlign))
   else begin
      if sd = '' then sd:= int2str(FColumnWidth);
      if se = '' then se:= int2str(integer(FTextAlign));
      s:= ss + '=' + sd + '=' + sh + '=' + se;
   end;
   Result:= s;
end;

//--------------------       ----------------------

//CountCol -   
//
procedure ThiMTStrTbl._var_CountCol;
begin
   dtInteger(_Data,CList.Count);
end;

//EndIdxCol -    
//
procedure ThiMTStrTbl._var_EndIdxCol;
begin
   if CList.Count = 0 then dtNull(_Data)
   else dtInteger(_Data,CList.Count - 1);
end;

//#####################################################################
//#                                                                   #
//#                                                #
//#                                                                   #
//#####################################################################

//Matrix -  
//
procedure ThiMTStrTbl._var_Matrix;
begin
   if not Assigned(Obj) then begin
      New(Obj);
      Obj._Set  := MX_Set;
      Obj._Get  := MX_Get;
      Obj._Rows := _mRows; 
      Obj._Cols := _mCols; 
   end;
   dtMatrix(_Data,Obj);
end;

function ThiMTStrTbl.MX_Get;
begin
   if (x >= 0) and (y >= 0) and (y < Control.Count) and (x < Control.LVColCount) then
      dtString(Result, Control.LVItems[y,x])
   else dtNull(Result);
end;

procedure ThiMTStrTbl.MX_Set;
begin
   if (x >= 0) and (y >= 0) and (y < Control.Count) and (x < Control.LVColCount) then
     Control.LVItems[y,x]:= ToString(Val);
end;

function ThiMTStrTbl._mRows;
begin
  Result := Control.Count; 
end;

function ThiMTStrTbl._mCols;
begin
  Result := Control.LVColCount; 
end;

//---------------        ---------------

//EndEdit -         0,
//               
//
procedure ThiMTStrTbl._work_doEndEdit;
begin
   if not FRedaction then Exit;
   if  ReadInteger(_Data,_data_EndEdit,0) = 0 then
      Control.Perform(WM_KEYDOWN,27,0)
   else
      Control.Perform(WM_JUSTFREE,0,0);
end;

//#####################################################################
//#                                                                   #
//#                           MT-                               #
//#                                                                   #
//#####################################################################

// MT-    
//
procedure ThiMTStrTbl.MT_ActionItm; // 
var   Row,Col,iconum,ind:integer;
      ss:string;
      DColor:dword;
begin
   Row:= Control.Count;
   if (Mode = ITM_INSERT) or (Mode = ITM_REPLACE) then
      if not _IsNULL(Data) then begin
         Row:= ReadInteger(Data,Null);   
         if (Row > Control.Count - 1) then exit;
      end;
   Col:= 0;
   iconum:= I_SKIP;
   DColor:= 0;
   if Assigned(SmIlist) and not _IsNULL(Data) then begin
      iconum:= ReadInteger(Data,Null);
      if iconum > SmIList.Count - 1 then iconum:= I_SKIP;
   end;
   if FColorItems and not _IsNULL(Data) then begin
      ss := ReadString(Data,Null) + _ColorDlm;
      DColor:= dword(Str2Int(GetTok(ss,_ColorDlm)) shl 24 + Str2int(ss));
   end;
   if not _IsNULL(Data) and not (Row < 0) then begin
      if Mode = ITM_ADD then
         Control.LVItemAdd('')
      else if (Mode = ITM_INSERT) and (Row < Control.Count) then
         Control.LVItemInsert(Row,'');     
      ind := Control.LVCurItem; //   
      while not _IsNULL(Data) and (Row < Control.Count) do begin
         Control.LVSetItem(Row,Col,ReadString(Data,Null),iconum,[],I_SKIP,I_SKIP,DColor);
         inc(Col);
      end;
      Control.LVCurItem := ind; //   
   end;
end;

// MT-   
//
procedure ThiMTStrTbl.MT_ActionCol; // 
var   s:string;
      ind:integer;
begin
   if _IsNULL(Data) then exit;

   ind:=ReadInteger(Data,Null); 
   s:=ReadString(Data,Null);   
   Replace(s, _ColDlm, '=');
   if (Mode = ITM_INSERT) and (ind >= 0) then begin
      if (ind > CList.Count - 1) then begin
         Control.LVColAdd('',FTextAlign,FColumnWidth);
         CList.Add(InitColStr(s));
      end
      else begin
         Control.LVColInsert(ind,'',FTextAlign,FColumnWidth);
         CList.Insert(ind,InitColStr(s));
      end;
   end
   else if (Mode = ITM_REPLACE) and not ((ind < 0)or(ind > CList.Count - 1)) then
      CList.Items[ind]:= InitColStr(s)
   else exit;
   SetColumns(CList,1);
end;

// MT-    
//
procedure ThiMTStrTbl.MT_ProperCol; // 
var   s,name,width,imgidx,aligntxt:string;
      ind:integer;
begin
   if _IsNULL(Data) then exit;

   ind:=ReadInteger(Data,Null);   
   s:=ReadString(Data,Null);   
   if (ind < 0) or (ind > CList.Count - 1) then exit;
   name:= Control.LVColText[ind];
   width:= int2str(Control.LVColWidth[ind]);
   imgidx:=int2str(Control.LVColImage[ind]);
   aligntxt:=int2str(integer(Control.LVColAlign[ind]));  
   if Mode = COL_NAME then name:= s
   else if Mode = COL_WIDTH then width:= s
   else if Mode = COL_IMAGE then imgidx:= s
   else if Mode = COL_ALIGN then aligntxt:= s
   else exit;   
   s:= name + '=' + width + '=' + imgidx + '=' + aligntxt;
   CList.Items[ind]:= InitColStr(s);
   SetColumns(CList,1);
end;

//doMT_CheckBox - / ,  MT-,
//                   - 
//                - (  (-1 - ))( (0 - ; 1 - ; 2 - ))
//
procedure ThiMTStrTbl._work_doMT_CheckBox; // 
var   idx,val:integer;
begin
   if _IsNULL(_Data) then exit;

   idx := ReadInteger(_Data,Null);
   val := ReadInteger(_Data,Null);

   if (idx >= -1) and (idx < Control.Count ) then Control.LVItemStateImgIdx[idx]:= val;
end;

//
//AllSelect_MT -  MT-   
//
procedure ThiMTStrTbl._var_AllSelect_MT; // 
var   i,j:integer;
      d:PData;
begin
   FreeData(@FData);
   FreeData(@FData_2);
   dtNull(FData);
   dtNull(FData_2);
   i:= Control.LVCurItem;
   if Control.LVSelCount > 0 then begin
      repeat
         dtInteger(FData_2,i);
         AddMTData(@FData,@FData_2,d); 
         j:= Control.LVNextSelected(i);
         i:= j;
      until j < 0;
   end;
   _Data := FData;
end;
//
//AllCheck_MT -  MT-     
//
procedure ThiMTStrTbl._var_AllCheck_MT; // 
var   i,j: word;
      d:PData;
begin
   FreeData(@FData);
   FreeData(@FData_2);
   dtNull(FData);
   dtNull(FData_2);
   if Control.Count > 0 then begin
      for i:=0 to Control.Count - 1 do begin
         j:= Control.LVItemStateImgIdx[i];
         if j > 1 then 
            dtInteger(FData_2,i)
         else
            dtNull(FData_2); 
         AddMTData(@FData,@FData_2,d);
      end;
   end;
   _Data := FData;
end;

//
//    
//
procedure ThiMTStrTbl.SetLargIconsManager;
begin
  if value <> nil then
  begin
    FLargIconsManager := value;
    LgIList := value.iconList;
    if Assigned(Control) then
      Control.ImageListNormal := LgIList;
  end;
end;

procedure ThiMTStrTbl.SetSmallIconsManager;
begin
  if value <> nil then
  begin
    FSmallIconsManager := value;
    SmIList := value.iconList; 
    FImgSize := value.imgsz;
    SmIList.BkColor:= FIconColColor;
    Control.ImageListSmall := SmIList;
    SetColumns(CList,1);  
  end;
end;

procedure ThiMTStrTbl.SetStateIconsManager;
begin
  if value <> nil then
  begin
    FStateIconsManager := value;
    StIList := value.iconList;
    if Assigned(Control) then
      Control.ImageListState := StIList;
  end;
end;

//
//----------------------------      ------------------------------
end.